'Rlog.bas, 1k...10M, Logaritmierung zur Feuchtemessung

$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 8
$swstack = 4
$framesize = 4


Dim Count As Word
Dim R As Word
Dim Ll As Byte
Dim Hl As Byte
Dim F As Word
Dim Rf As Byte
Led2 Alias Portb.3

Open "comb.1:9600,8,n,1,INVERTED" For Output As #1

Do
  Count = 0
  Loadadr Count , Z
  Portb.3 = 1
  Ddrb.3 = 1                                                'Laden
  Waitms 500
  Portb.3 = 0                                               'Entladem
  Waitus 10
  Ddrb.3 = 0

  $asm                                                      'Messen in Asm
  Messure:
   adiw r24, 1
   breq break
   sbis pinb, 3
   rjmp messure
  Break:
   st Z+, r24
   St Z, r25
  $end Asm

  Portb.3 = 1
  Ddrb.3 = 1
  If Count = 0 Then Count = 1
 ' Print #1 , Count
  Hl = 15                                                   'log zut Basis 2
  While Count.15 = 0
    Shift Count , Left
    Hl = Hl - 1
  Wend
  Ll = High(count)
  Shift Ll , Right , 3
  Ll = Ll And 15
  Shift Hl , Left , 4
  Hl = Hl + Ll                                              'bei 80%, 5,2k, Log = 50, bei 40% 400k, Log =145
  F = Hl
  F = F * 109
  Shift F , Right , 8
  Rf = F                                                    '/ 2,34
  Rf = 101 - Rf
  Put #1 , Rf                                               'relative Feuchte
Loop

End